import React, { createContext, useRef } from "preact/compat";
export const __DocContext = createContext({
    head: { current: [] },
    hydrate: { current: [] },
});
export const __hydratedComponents = [];
const unique = (value, index, self) => self.indexOf(value) === index;
import render from "preact-render-to-string";
export const Document = ({ hydrateExportManifest, page, styles = [], hasScripts = false, children, }) => {
    const head = useRef([]);
    const hydrate = useRef([]);
    const subtree = render(React.createElement(__DocContext.Provider, { value: { head, hydrate } }, children), {}, { pretty: true });
    const components = hydrate.current.map(({ name }) => name).filter(unique);
    if (hydrate.current.length > 0)
        __hydratedComponents.push({ page, components });
    const componentStyles = components
        .map((name) => {
        const found = hydrateExportManifest.find((entry) => entry.exports.includes(name));
        if (found)
            return found.styles;
        return null;
    })
        .filter((v) => v)
        .join("")
        .trim();
    return (React.createElement("html", null,
        React.createElement("head", null,
            React.createElement("meta", { charSet: "utf-8" }),
            React.createElement("meta", { name: "viewport", content: "width=device-width" }),
            React.createElement(React.Fragment, null, head.current),
            React.createElement("style", { dangerouslySetInnerHTML: {
                    __html: "[data-hydrate]{display:contents;}",
                } }),
            styles.map((style) => (React.createElement("style", { dangerouslySetInnerHTML: { __html: style.trim() } }))),
            componentStyles && (React.createElement("style", { dangerouslySetInnerHTML: { __html: componentStyles } }))),
        React.createElement("body", null,
            React.createElement("div", { id: "__microsite", dangerouslySetInnerHTML: { __html: subtree } }),
            hydrate.current.length > 0 && (React.createElement("script", { type: "module", defer: true, src: `/_hydrate/pages/${page}.js` })),
            hasScripts ? (React.createElement(React.Fragment, null,
                React.createElement("script", { type: "module", src: "/index.js" }),
                React.createElement("script", Object.assign({}, { nomodule: "" }, { src: "https://unpkg.com/systemjs@2.0.0/dist/s.min.js" })),
                React.createElement("script", Object.assign({}, { nomodule: "" }, { src: "/index.legacy.js" })))) : null)));
};
